#include "WindowFrame.h"

#define IMAGECLASS WindowImg
#define IMAGEFILE <MDITest/Window.iml>
#include <Draw/iml_source.h>

void TitleFrame::LeftUp(Point p, dword keyflags)	
{ 
	if (close == CTRL_PRESSED) 
	{ 
		close = CTRL_HOT; 
		WhenClose(); 
		Refresh(); 
	}
}

void TitleFrame::MouseMove(Point p, dword keyflags)	
{ 
	if (close >= 0 && CloseRect(GetSize()).Contains(p)) 
	{ 
		close = GetMouseLeft() ? CTRL_PRESSED : CTRL_HOT; 
		Refresh(); 
	}
	else if (close > 0) {
		close = CTRL_NORMAL;
		Refresh();
	}		
}

void TitleFrame::Paint(Draw& w)
{
	const Style *st = St();
	Rect r = GetSize();	
	Rect br = CloseRect(r);

	ChPaint(w, r, st->background[focuslook]);
	r.left += 2;
	r.right = r.right - br.Height() - 1;
	if (img) {
		w.DrawImage(r.left + 2, (r.top + 1 + r.Height() - img.GetHeight())/2, img);	
		r.left += img.GetWidth() + 2;							
	}
	StdDisplay().Paint(w, r, title, st->text[focuslook], Null, 0);
	if (close >= 0) 
		ChPaint(w, br, st->close[close]);
}

Rect TitleFrame::CloseRect(Rect r)
{
	int bsz = r.Height() - 2;
	return Rect(r.right - bsz - 1, 1, r.right - 1, r.bottom - 1);
}

TitleFrame & TitleFrame::SetFocusLook(bool _focus, bool pfocus)
{
	if (pfocus && _focus && GetParent() && !GetParent()->HasFocusDeep()) GetParent()->SetFocus(); 
	if (focuslook != _focus) {
		focuslook = _focus; 
		Refresh();
	} 
	return *this;
}

TitleFrame::TitleFrame()
{
	close = CTRL_NORMAL;
	style = NULL;
	focuslook = false;
	WantFocus(false);
}

CH_STYLE(TitleFrame, Style, StyleDefault)
{
	background[0] = WindowImg::BG(); // No focus
	background[1] = WindowImg::BGf(); // No focus
	text[0]		= SBlack(); // No focus
	text[1]		= SWhite(); // Focus
	close[0] 	= WindowImg::CR0();
	close[1] 	= WindowImg::CR1();
	close[2] 	= WindowImg::CR2();
	close[3] 	= WindowImg::CR3();
	font		= StdFont(12);
}

